From 8bd1aa1d4d6af5616977bb4b7f9a9f47e942c921 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jan 31 2017 18:25:56 +0000
Subject: [PATCH 683/1001] Protect widget views against uninitialized DB


---

diff --git a/hubs/views/__init__.py b/hubs/views/__init__.py
index 13fb79c..f39cc0c 100644
--- a/hubs/views/__init__.py
+++ b/hubs/views/__init__.py
@@ -14,6 +14,7 @@ from .plus_plus import *
 import flask
 import functools
 import hubs.models
+from sqlalchemy.exc import OperationalError
 from sqlalchemy.orm.exc import NoResultFound
 from hubs.app import app, session
 from .utils import get_widget
@@ -34,13 +35,19 @@ def _widget_view_decorator(func):
         return func(session, widget, *args, **kwargs)
     return inner
 
-for widget in session.query(hubs.models.Widget):
-    for params in getattr(widget.module, 'ROUTES', []):
-        params["rule"] = "/<hub>/<int:idx>/widget/" \
-                         + params["rule"].lstrip("/")
-        if not params.get("endpoint"):
-            params["endpoint"] = params["view_func_name"]
-        params["endpoint"] = "%s_%s" % (widget.plugin, params["endpoint"])
-        params["view_func"] = _widget_view_decorator(
-            getattr(widget.module, params.pop("view_func_name")))
-        app.add_url_rule(**params)
+def _load_widget_views():
+    for widget in session.query(hubs.models.Widget):
+        for params in getattr(widget.module, 'ROUTES', []):
+            params["rule"] = "/<hub>/<int:idx>/widget/" \
+                             + params["rule"].lstrip("/")
+            if not params.get("endpoint"):
+                params["endpoint"] = params["view_func_name"]
+            params["endpoint"] = "%s_%s" % (widget.plugin, params["endpoint"])
+            params["view_func"] = _widget_view_decorator(
+                getattr(widget.module, params.pop("view_func_name")))
+            app.add_url_rule(**params)
+
+try:
+    _load_widget_views()
+except OperationalError:
+    pass  # Maybe the DB is not yet initialized (tests).

